/*
	Box.h
	Application Kit, Release 2.0
	Copyright (c) 1988, 1989, 1990, NeXT, Inc.  All rights reserved. 
*/

#import "NSView.h"

/* Box title positions */

typedef enum _NSTitlePosition {
    NSNoTitle				= 0,
    NSAboveTop				= 1,
    NSAtTop				= 2,
    NSBelowTop				= 3,
    NSAboveBottom			= 4,
    NSAtBottom				= 5,
    NSBelowBottom			= 6
} NSTitlePosition;

@interface NSBox : NSView
{
    id                  cell;
    id                  contentView;
    NSSize              offsets;
    NSRect              borderRect;
    NSRect              titleRect;
    struct _bFlags {
#ifdef __BIG_ENDIAN__
	unsigned int        borderType:2;
	unsigned int        titlePosition:3;
	unsigned int        _transparent:1;
	unsigned int        _RESERVED:10;
#else
	unsigned int        _RESERVED:10;
	unsigned int        _transparent:1;
	unsigned int        titlePosition:3;
	unsigned int        borderType:2;
#endif
    }                   bFlags;
}

- initFrame:(NSRect)frameRect;

- (NSBorderType)borderType;
- (NSTitlePosition)titlePosition;
- setBorderType:(NSBorderType)aType;
- setTitlePosition:(NSTitlePosition)aPosition;
- (NSString *)title;
- setTitle:(NSString *)aString;
- cell;
- font;
- setFont:fontObj;
- (NSSize)offsets;
- setContentViewMargins:(NSSize)_offsetSize;
- setFrameSize:(NSSize)newSize;
- sizeToFit;
- setFrameFromContentFrame:(NSRect)contentFrame;
- contentView;
- setContentView:aView;
- addSubview:aView;
- replaceSubview:oldView with:newView;
- drawRect:(NSRect)rect;

@end
