/*
	ClientInputManager.h
	Application Kit, Release 2.1J
  	Copyright 1990, 1991 Canon, Inc.
*/

#ifdef KANJI

#import <Foundation/NSObject.h>
#import <DPSClient/dpsclient.h>

//	mouse-click-part
#define NSFrontIMHalf		0x0
#define NSBackIMHalf		0x1

//	input-support-level
#define NSIMNoSupport			0x0
#define NSIMWindowInput			0x1
#define NSIMInlineInput			0x2
#define NSIMColorInlineInput		0x3

#define NSIMColorInlineInput		0x3	// for backward compatibility

//	character-attribute
#define	NSNoIMAttribute	0x0
#define	NSUnderlineIMAttribute		0x1
#define	NSIMHighlightModeMatrix		0x2

//	Default database parameter for port name used to communicate with an 
//	input manager
#define NSInputManagerPortName	"InputManager"

typedef struct _IMStartKey {
	unsigned short	code;
	int				flags;
} IMStartKey;

@interface NSClientInputManager:NSObject
{
	id				delegate;
	char				*imPortName;

	id				_support; // 	_IMIpcHandler
	int				_ctxt;	// 	contextNum
	id				_responder;	//	first-responder
	int				_displaySupportLevel;
	
	IMStartKey		*_startKeys;
	int				_keyCount;
	
	int				_return_int;	
	void				*_return_ptr;
	
	struct {
		unsigned int        getCmdKey			:1;
		unsigned int        imOn				:1;
		unsigned int        autoConnect		:1;
		unsigned int        _connectable		:1;
		unsigned int        _connected			:1;
		unsigned int        _displayDidCheck	:1;
		unsigned int        _canDisplay		:1;
		unsigned int        _setDeadKeyFlag	:1;
	}                   		_flags;

	int			_enableDeadKeys;
	int			_count;
}

- init;
- (NSString *)imPortName;
- setIMPortName:(NSString *)name;
- (void)dealloc;
- setDelegate:obj;
- delegate;
- setAutoConnect:(BOOL)flag;
- imGetCommandKeyFirst:(BOOL)flag;
- (int)imReturnINT;
- imReturnID;
- (BOOL)imReturnBOOL;
- (NSString *)imReturnSTR;
- (void *)imReturnPTR;

- (int)imSendMessage: (SEL)selector, ...;
- (int)imSendRecMessage: (SEL)selector, ...;

@end

@interface NSClientInputManager(CimInterface)

- imBeginSession;
- imEndSession;
- imProcessEvent:(NXEvent *)anEvent from:sender;

- (int)imNotifyResponderWillChange;
- (int)imNotifyResponderDidChange:(int)supportLevel;
- (int)imNotifyActivated;
- (int)imNotifyDeactivated;

- imAppDidBecomeActive;
- imAppDidResignActive;
- imKeyWindowWillChange:sender;
- imKeyWindowDidChange:sender;
- imFirstResponderWillChange:sender;
- imFirstResponderDidChange:sender;
- imTrapMouseAction:target;

- imCancelInput;
- imSendInput;
- imInsertionWillChange:sender;
- imMouseDownAt:(int)pos :(int)part clickCount:(int)count keyState:(int)flag;
- imMouseDraggedAt:(int)pos :(int)part keyState:(int)flag;
- imMouseUpAt:(int)pos :(int)part clickCount:(int)count keyState:(int)flag;
- (BOOL)imIsCommunicating;
- (NSString *)imCurrentInputMode;
- (NSString *)imName;
- (NSString *)imVersion;
- imResponderDidFree:sender;

@end

#endif
